#!/bin/bash

# List all Hotspot connections
hotspot_connections=$(nmcli connection show | grep Hotspot | awk '{print $1}')

# Loop through each Hotspot connection and delete it
for connection in $hotspot_connections; do
    echo "Deleting Hotspot connection: $connection"
    nmcli connection delete "$connection"
done

echo "All Hotspot connections have been deleted."
