// Jscript Functions
// Clock setup

function startTime() {
    //
    var realtime = +Date.now() + timeDiff;
    var date = new Date(realtime);
    var hours = date.getHours();
    var ampm = hours >= 12? 'pm' : 'am';
    if (hours > 12) {hours =  hours - 12};
    var minutes = date.getMinutes();
    var seconds = date.getSeconds();
    minutes = checkTime(minutes);
    seconds = checkTime(seconds);

    var formattedTime = hours + ':' + minutes + ':' + seconds +' ' + ampm;

    document.getElementById('clock').innerHTML = formattedTime;
    var t = setTimeout(startTime, 1000);
}

function flagchanged(felement) {
    console.log("-Set background-");
    //console.log(felement);
    var element = document.getElementsByName(felement);
    element[0].style.backgroundColor = "yellow";
    felement = "submit";
    //console.log(felement);
    var element = document.getElementsByName(felement);
    element[0].style.backgroundColor = "yellow";
  }

function checkTime(i) {
    if (i < 10) {i = "0" + i};  // add zero in front of numbers < 10
    return i;
}

function onloadsetup(){
    startTime();
    //mqtt_set_current();
    console.log("Setup");
    var tx_method = document.getElementById('tx_method');
    if(tx_method){
        setmethod("tx_method");
        document.getElementById('toggleButton').addEventListener('click', function() {
        var passwordField = document.getElementById('sftp_password');
        console.log("toggle");
        if (passwordField.type === 'password') {
            passwordField.type = 'text';
            this.textContent = 'Hide Password';
        } else {
            passwordField.type = 'password';
            this.textContent = 'Show Password';
        }
        });
    }
}

function setmethod(name){
    console.log(name);
    var method = document.getElementById(name).value;
    console.log(method);
    if (method == "Windows") {
        document.getElementById('Linux').style.display = 'none';
        document.getElementById('Windows').style.display = 'block';
    }else{
        document.getElementById('Windows').style.display = 'none';
        document.getElementById('Linux').style.display = 'block';
    }
}

function ClearFunction() { location.href = '/sensorlist.php?clearlist'; }

function SendCmdFunction() { location.href = '/sendonstarted.php'; }


function showSecurity() {
            alert('Make the connection to the PrivateEyePi Server Secure & Encrypted, or use an UnSecure connection to the server.(aka HTTP/HTTPS)' +
                ' If unsure, try the Secure option first. Some servers will not accept a Secure Connection and will require the UnSecure option.');
        }

function showUpdate() { alert('There are OS updates for you Gateway, when current this button will not be displayed.'); }

// Update Status fields on Form
//
async function fetchStatus() {
    try {
        const response = await fetch('connectstatus.php');
        if (!response.ok) {
            throw new Error('Network response was not ok ' + response.statusText);
        }
        const data = await response.json();
        updateStatuses(data);
    } catch (error) {
        console.error('There was a problem with the fetch operation:', error);
    }
}

function updateStatuses(statuses) {
    if (statuses.item1) {
        document.getElementById('serverconnect').textContent = 'JemRF: ' + statuses.item1;
    }
    if (statuses.item2) {
        document.getElementById('mqttconnect').textContent = ' MQTT: ' + statuses.item2;
    }
    if (statuses.item3) {
        document.getElementById('wlanip').textContent = 'WLAN: ' + statuses.item3;
    }
    if (statuses.item4) {
        const healthStatusElement = document.getElementById('healthstatus');
        if (healthStatusElement) {
            healthStatusElement.style.background = statuses.item4;
        }
    }
}

// Call fetchStatus every 10 seconds (5000 milliseconds)
setInterval(fetchStatus, 10000);
