<?php include 'dbconnect.php'; ?>
<?php
$reset = 0;
if (isset($_GET["reset"])) {
    //echo "reset";
    readControl();
    $mqtt_broker = "mqtt.jemrf.com";
    $mqtt_port = "1883";
    $mqtt_username = "jemrf";
    $mqtt_password = "mqtt4Jemrf";
    $mqtt_clientid = "";
    $mqtt_subscribe = "";
    $mqtt_enable = 0;
    $mqtt_dataformat = 1;
    $reset = 1;
    // write db updates
    #updateControl();
// ['MQTTEnabled','MQTTVersion','MQTTStart','MQTTPID','MQTTBroker','MQTTPort','MQTTUser','MQTTPass','MQTTTopic','MQTTFormat']
    //echo "Clear update db";

} else {
    if ($_GET['submit'] == 'Save') {
        readControl();
        $mqtt_broker = htmlentities($_GET['mqtt_broker']);
        $mqtt_port = htmlentities($_GET['mqtt_port']);
        $mqtt_username = htmlentities($_GET['mqtt_username']);
        $mqtt_password = htmlentities($_GET['mqtt_password']);
        $mqtt_clientid = htmlentities($_GET['mqtt_clientid']);
        $mqtt_subscribe = htmlentities($_GET['mqtt_subscribe']);
        $mqtt_enable = htmlentities($_GET['mqtt_enable']);
        $mqtt_dataformat = htmlentities($_GET['mqtt_dataformat']);
        $mqtt_allcustom = 99; // allow regression testing to run
        $mqtt_allcustom = htmlentities($_GET['mqtt_allcustom']);
        $mqtt_nodeid = htmlentities($_GET['mqtt_nodeid']);
        if ($mqtt_allcustom == 1){
            if ($nodeid[0] == 1 and strlen($mqtt_nodeid) > 4){
                if ($nodeid[1] != $mqtt_nodeid ){
                    $updatecommand = "sudo systemctl restart gw-send";
                    $file = fopen("update_cmd.txt", "w");
                    fwrite($file, $updatecommand);
                    fclose($file);
                }
                $sql = "update control set Ctext = '$mqtt_nodeid' where Control ='NodeId'";
                $result = mysqli_query($LinkId, $sql);
            }
            $sql = "update control set Cnumber = 1 where Control ='NodeId'";
            $result = mysqli_query($LinkId, $sql);

        }else{
            if ($nodeid[0] == 1 and $mqtt_allcustom = 0){
                // Restart commander to reset Id
                $updatecommand = "sudo systemctl restart gw-cmd gw-send";
                $file = fopen("update_cmd.txt", "w");
                fwrite($file, $updatecommand);
                fclose($file);
            }
            $sql = "update control set Cnumber = 0 where Control ='NodeId'";
            $result = mysqli_query($LinkId, $sql);

        }
        // write db updates
        //echo "Update db";
        updateControl();
        readControl();
    } else {
        // read from database here
        readControl();
    }
}

// Get list of available SSIDs
function readControl(){
    global $LinkId,$mqtt_broker,$mqtt_port,$mqtt_username,$mqtt_password,$mqtt_subscribe,$mqtt_enable,$timezone,$mqtt_dataformat,$mqtt_clientid,$wlanip,
    $deviceid,$serverstatus,$mqttstatus,$mqtt_status,$mqtt_reasoncode,$mqtt_rctext,$rfversion,$rfdevid,$rfchannel,$nodeid ;

    $sql = "select * from control";
    $control[] = array();
    $result = mysqli_query($LinkId, $sql);
    while ($row = mysqli_fetch_array($result)) {
        $control[$row["Control"]] = [$row["Cnumber"] ,$row["Ctext"]];
    }
    // Header Fields
    $wlanip = $control['IP'][1];
    $nodeid = $control['NodeId'];
    $deviceid = "JRF".$nodeid[1];
    $timezone = $control['Timezone'][1];
    $rfversion = $control['RFVersion'][1];
    $rfchannel = $control["RFChannel"][0];
    $rfdevid = $control['RFDeviceId'][1];
    $serverstatus = $control["ServerStatus"][0];
    $mqttstatus = $control["MQTTStatus"][0];

    $mqtt_broker = $control['MQTTBroker'][1];
    $mqtt_port = $control['MQTTPort'][1];
    $mqtt_username =$control['MQTTUser'][1];
    $mqtt_password =$control['MQTTPass'][1];
    $mqtt_clientid = $control['MQTTClientId'][1];
    $mqtt_subscribe = $control['MQTTTopic'][1];
    $mqtt_enable = $control['MQTTEnabled'][0];
    $mqtt_status = $control['MQTTStatus'][0];
    $mqtt_dataformat =$control['MQTTFormat'][0];
    $mqtt_reasoncode = $control['MQTTrc'][0];
    $mqtt_rctext =$control['MQTTrc'][1];
}

function updateControl(){
    global $LinkId,$mqtt_broker,$mqtt_port,$mqtt_username,$mqtt_password,$mqtt_subscribe,$mqtt_enable,$mqtt_dataformat,$mqtt_clientid,$mqtt_status;

    $sql = "update control set Ctext = '$mqtt_broker' where Control ='MQTTBroker'";
    $result = mysqli_query($LinkId, $sql);
    $sql = "update control set Ctext = '$mqtt_port' where Control ='MQTTPort'";
    $result = mysqli_query($LinkId, $sql);
    $sql = "update control set Ctext = '$mqtt_username' where Control = 'MQTTUser'";
    $result = mysqli_query($LinkId, $sql);
    $sql = "update control set Ctext = '$mqtt_password' where Control = 'MQTTPass'";
    $result = mysqli_query($LinkId, $sql);
    $sql = "update control set Ctext = '$mqtt_clientid' where Control = 'MQTTClientId'";
    $result = mysqli_query($LinkId, $sql);
    $sql = "update control set CNumber = '$mqtt_dataformat' where Control = 'MQTTFormat'";
    $result = mysqli_query($LinkId, $sql);
    $sql = "update control set Ctext = '$mqtt_subscribe' where Control = 'MQTTTopic'";
    if ($mqtt_dataformat == "4" AND substr($mqtt_subscribe,0,7) !="spBv1.0"){
        $sql = "update control set Ctext = 'spBv1.0/JemRFDevices' where Control = 'MQTTTopic'";
    }
    $result = mysqli_query($LinkId, $sql);

    $sql = "update control set Cnumber = '$mqtt_enable' where Control = 'MQTTEnabled'";
    $result = mysqli_query($LinkId, $sql);

    if (!$result) {
        echo "Error: ". $sql. "<br>". mysqli_error($LinkId);
    }

}
date_default_timezone_set($timezone);
$datetime = date('Y-m-d H:i:s', time());
include 'header.php';

?>
<tr>
    <td columspan='2'>
        <table align='center'>
            <tr>
                <td colspan='2'><span style='color:red;font-family:verdana;font-size:12px;text-align: center;'></span>
                </td>
            </tr>
            <script>
                function disableField(val) {
                    var clientid = document.getElementById('clientid');
                    var subscribe = document.getElementById('subscribe');
                    var checkbox = document.getElementById('custom');
                    clientid.enable = (checkbox.checked);
                    subscribe.enable = (checkbox.checked);
                    console.log(checkbox)
                }

                function mqtt_set_current() {
                    document.getElementById('mqtt_dataformat').value = '1';
                    console.log('mqtt_dataformat loaded');
                }
            </script>
            <form method='get' action='/mqttset.php'>
                <tr>
                    <td style='text-align: right; color:black;'>MQTT Broker : </td>
                    <td style='text-align: left' ;>
                        <input type='text' name='mqtt_broker' value='<?php echo $mqtt_broker ?>' onchange="flagchanged(name);">
                    </td>
                </tr>
                <tr>
                    <td style='text-align: right; color:black;'>MQTT Port : </td>
                    <td style='text-align: left' ;>
                        <input type='text' name='mqtt_port' value='<?php echo $mqtt_port ?>' onchange="flagchanged(name);">
                    </td>
                </tr>
                <tr>
                    <td style='text-align: right; color:black;'>MQTT User : </td>
                    <td style='text-align: left' ;>
                        <input type='text' name='mqtt_username' value='<?php echo $mqtt_username ?>' onchange="flagchanged(name);">
                    </td>
                </tr>
                <tr>
                    <td style='text-align: right; color:black;'>MQTT Password : </td>
                    <td style='text-align: left' ;><input type='text' name='mqtt_password' value='<?php echo $mqtt_password ?>' onchange="flagchanged(name);"></td>
                </tr>
                <tr>
                    <td style='text-align: right; color:black;'>MQTT Custom Client Id : </td>
                    <td style='text-align: left' ;><input type='text' name='mqtt_clientid' id='mqtt_clientid' value='<?php echo $mqtt_clientid ?>' onchange="flagchanged(name);"></td>
                </tr>
                <tr>
                    <td style='text-align: right; color:black;'>MQTT Custom Subscribe : </td>
                    <td style='text-align: left' ;><input type='text' name='mqtt_subscribe' id='mqtt_subscribe' value='<?php echo $mqtt_subscribe ?>' onchange="flagchanged(name);"></td>
                </tr>
                <tr>
                    <td style='text-align: right; color:black;'>Allow Custom Device Id: </td>
                    <td style='text-align: left' ;><Select name='mqtt_allcustom' onchange="flagchanged(name);">
                        <?php if($nodeid[0] == 0){?>
                            <option value='0' Selected>Disabled</option>
                            <option value='1'>Enabled</option>
                            <?php }else{?>
                            <option value='0' >Disabled</option>
                            <option value='1' Selected>Enabled</option>
                            <?php }?>

                        </Select>
                    </td>
                </tr>
                <tr>
                    <td style='text-align: right; color:black;'>MQTT Custom Device Id : </td>
                    <td style='text-align: left' ;><input type='text' name='mqtt_nodeid' id='mqtt_nodeid' <?php if($nodeid[0] == 0) echo 'disabled'; ?> value='<?php echo $nodeid[1] ?>' onchange="flagchanged(name);"></td>
                </tr>
                <tr>
                    <td style='text-align: right; color:black;'>MQTT Data Format : </td>
                    <td style='text-align: left' ;><Select name='mqtt_dataformat' id='mqtt_dataformat' onchange="flagchanged(name);">
                            <?php
                            switch ($mqtt_dataformat) {
                                case 1:
                            ?>
                                    <option value='1' Selected>JemRF</option>"
                                    <option value='2'>Cayenne</option>"
                                    <option value='3'>JSON</option>"
                                    <option value='4'>SparkplugBv1</option>"
                                <?php
                                    break;
                                case 2:
                                ?>
                                    <option value='1'>JemRF</option>"
                                    <option value='2' Selected>Cayenne</option>"
                                    <option value='3'>JSON</option>"
                                    <option value='4'>SparkplugBv1</option>"
                                <?php
                                    break;
                                case 3:
                                ?>
                                    <option value='1'>JemRF</option>"
                                    <option value='2'>Cayenne</option>"
                                    <option value='3' Selected>JSON</option>"
                                    <option value='4'>SparkplugBv1</option>"
                                <?php
                                    break;
                                case 4:
                                ?>
                                    <option value='1'>JemRF</option>"
                                    <option value='2'>Cayenne</option>"
                                    <option value='3'>JSON</option>"
                                    <option value='4' Selected>SparkplugBv3.0</option>"
                            <?php
                            }
                            ?>
                        </Select></td>
                </tr>
                <tr>
                    <td><br /></td>
                    <td>
                </tr>
                <tr>
                    <td style='text-align: right; color:black;'>MQTT : </td>
                    <td style='text-align: left' ;><Select name='mqtt_enable' onchange="flagchanged(name);">
                        <?php if($mqtt_enable == 0){?>
                            <option value='0' Selected>Disabled</option>
                            <option value='1'>Enabled</option>
                            <?php }else{?>
                            <option value='0' >Disabled</option>
                            <option value='1' Selected>Enabled</option>
                            <?php }?>

                        </Select>
                    </td>
                </tr>
                <tr>
                    <td style='text-align: right; color:black;'>MQTT Status: </td>
                    <td style='text-align: left'>
                        <?php
                        if ($mqtt_status) {
                            echo "Connected";
                        } else {
                            echo "Not Connected";
                        } ?>
                    </td>
                </tr>
                <tr>
                    <td style='text-align: right; color:black;'>MQTT Connection Code: </td>
                    <td style='text-align: left'>
                        <?php
                        if ($mqtt_reasoncode == 0) {
                            echo "None";
                        } else {
                            echo $mqtt_reasoncode,' - ',$mqtt_rctext;
                        } ?>
                    </td>
                </tr>
                <tr><td>
                <input type='submit' name='submit' style='font-size:14px; border-radius:15px;-moz-border-radius:15px;-webkit-border-radius:15px; height:40px; width:90px; color: black; background-color:
                    <?php if ($reset == 1){ echo "yellow"; }else {echo "#C0C0C0";} ?>;' value='Save'>&nbsp;&nbsp;&nbsp;</td>
                    <td>
                        <button style='text-align: center;font-size:14px; border-radius:15px;-moz-border-radius:15px;-webkit-border-radius:15px; height:40px; width:110px; color: black; background-color: #C0C0C0;'>
                            <a href='/mqttset.php?reset'>Reset Form
                    </td>
                </tr>
            </form>
        </table>
    </td>
</tr>
<?php include 'footer.php'; ?>