# gw2mqttsend.py
from dbfunctions import dbopen,write_control_n,write_control_t,write_control,read_control,dbsql,dbsqlw,dbopeninit,dbsql2
from utilities import getgwid, set_prefix, printm
import mqtt_utilities as mqtt
import time
import json

def send_mqtt(mqtt_send, fifo_index, spbsequence,rxtime,healthevent):
    global mqttc, nodeId
    #print("mqtt Send")
    mqtt_enabled = read_control(0,'MQTTEnabled')
    nodeId = read_control(0,'NodeId')
    nodeId = 'JRF' + nodeId[3]
    mqtt_status = read_control(0,'MQTTStatus')
    mqtt_format = read_control(0,'MQTTFormat')
    mqtt_format = mqtt_format[2]

    if mqtt_enabled[2] == 1:
        # Is it connected
        #print("MQTT Status: ",mqtt_status)
        if mqtt_status[2] == 0:
            mqtt.mqtt_establish()
            time.sleep(1)
            mqtt_status = read_control(0,'MQTTStatus')
            time.sleep(4)
            if mqtt_status[2] == 1:
                printm('MQTT Connected')
                if mqtt_format == 4:
                    # send NBIRTH
                    #
                    mqtt.enablesparkplug(nodeId)
                    # Send MQTT
        #
        # # Start mqtt
        mqtt_topic = read_control(0,'MQTTTopic')
        mqtt_topic = mqtt_topic[3]
        if len(mqtt_topic) > 2:
            mqtt_topic = mqtt_topic
        else:
            mqtt_topic = nodeId

        if healthevent != 0:
            mqtt_topic = mqtt_topic +'/health/'+healthevent

            #printm(f"Health Event MQTT Topic set to: {mqtt_topic} with value: {mqtt_send}")
            #mqtt.mqtt_publish(mqtt_topic, mqtt_send)
            #mqtt.mqtt_misc()
            sensor_id = mqtt_send[0]
            sensor_code = mqtt_send[1]
            sensor_value = mqtt_send[2]
            sensor_type = mqtt_send[3]
            sensor_unit = mqtt_send[4]

            #return
        else:
            #
            # If not healthevent continue
            #
            #printm(f'mqtt_send  = {mqtt_send}')
            sdata = mqtt.decode_message('{'+mqtt_send)

            sensor_id = sdata[0]
            sensor_id= sensor_id[3:]
            sensor_code = sdata[1]
            sensor_value = sdata[2]
            sensor_type = sdata[3]
            sensor_unit = sdata[4]

        printm("MQTT Sending ID = ", sensor_id,' ',sensor_code, "  payload = ",sensor_value)


        if mqtt_format == 1:
            # topic xxTTTT  data is value
            mqtt_topic += '/'  + sensor_id + sensor_code
            payload = sensor_value

        elif mqtt_format == 2:
            # topic xxTTTT  data is value
            mqtt_topic += '/' + sensor_id + sensor_code
            payload = sensor_value

        elif mqtt_format == 3:
            mqtt_topic += '/' + sensor_id
            # topic device Id   Data Json format  {"temperature":"77.558","unit_of_measurement":"F"}
            raw_payload = {sensor_type:sensor_value, "unit_of_measurement":sensor_unit}
            payload = json.dumps(raw_payload)

        elif mqtt_format == 4:
            # SparkPlugb V2
            #{"timestamp":1711858902,"metrics":[{"name":"device_type","properties":"Fahrenheit","alias":1,"timestamp":1711858902,"dataType":"Float","value":"sensor_value"}],"seq":3}
            #mqtt_topic +='/DDATA/'+ nodeId + '/' + sensor_id
            #raw_payload = '{' + '"timestamp":"' + str(int(time.time())) + '",' + '"metrics":' + '[' + '{' + '"name":"'  + sensor_type + '",' + '"properties":"' + sensor_unit + '",'
            #raw_payload += '"timestamp":"' + str(int(time.time())) + '",' + '"dataType":"9",' + '"value":"' + str(sensor_value) + '"}' + ']'
            #raw_payload += ',' + '"seq":"' + str(spbsequence) + '"}'
            #printm("sp send ",sensor_id," - ",sensor_type," - ",sensor_unit," - ",sensor_value," - ",rxtime)
            if healthevent != 0:
                sensor_id = 'health/'+healthevent
            mqtt.spsenddata(sensor_id,sensor_type,sensor_unit,sensor_value,rxtime)

        if mqtt_format != 4:
            #mqtt_establish()
            #printm("MQTT Topic set to: ",mqtt_topic," with value: ",payload)
            mqtt.mqtt_publish(mqtt_topic, payload)
            mqtt.mqtt_misc()
            # Update message sent
        cnx = 1
        dbsqlw(cnx,"update fifo set Smqtt = 1 where idfifo = " + str(fifo_index) + ';')

    elif mqtt_status[2] == 1:
            printm("MQTT was enabled and Connected, now disconnecting")
            #mqttc.loop_stop()
            write_control_n(0,'MQTTStatus',0)
            mqtt.mqtt_exit()