<?php
include 'dbconnect.php'; // Include database connection

// Query to fetch all rows from the 'control' table
$query = "SELECT * FROM control";
$result = $LinkId->query($query);

if ($result->num_rows > 0) {
    // Fetch all rows into an array
    $rows = [];
    while ($row = $result->fetch_assoc()) {
        $rows[] = $row;
    }

    // Split rows into two halves
    $half = ceil(count($rows) / 2);
    $leftRows = array_slice($rows, 0, $half);
    $rightRows = array_slice($rows, $half);

    echo "<div style='display: flex;'>";

    // Left table
    echo "<div style='flex: 1; margin-right: 10px;'>";
    echo "<table border='1' style='width: 100%;'>";
    echo "<tr>";
    foreach (array_keys($rows[0]) as $header) {
        echo "<th>" . htmlspecialchars($header) . "</th>";
    }
    echo "</tr>";
    foreach ($leftRows as $row) {
        echo "<tr>";
        foreach ($row as $value) {
            echo "<td>" . htmlspecialchars($value) . "</td>";
        }
        echo "</tr>";
    }
    echo "</table>";
    echo "</div>";

    // Right table
    echo "<div style='flex: 1;'>";
    echo "<table border='1' style='width: 100%;'>";
    echo "<tr>";
    foreach (array_keys($rows[0]) as $header) {
        echo "<th>" . htmlspecialchars($header) . "</th>";
    }
    echo "</tr>";
    foreach ($rightRows as $row) {
        echo "<tr>";
        foreach ($row as $value) {
            echo "<td>" . htmlspecialchars($value) . "</td>";
        }
        echo "</tr>";
    }
    echo "</table>";
    echo "</div>";

    echo "</div>";
} else {
    echo "No data found in the 'control' table.";
}

$LinkId->close(); // Close the database connection
?>
