<?php
// Get Header information
//
include 'dbconnect.php';
if ($_POST['submit'] == 'Save') {
    // Save the settings
    $new_sendcmd_enabled = $_POST['sendcmd_enabled'];
    if ($new_sendcmd_enabled != '0') {
        $change_channel = isset($_POST['change_channel']) ? $_POST['channel_value'] : null;
        $change_interval = isset($_POST['change_interval']) ? $_POST['interval_value'] : null; 
        $change_nomsg = isset($_POST['change_nomsg']) ? $_POST['nomsg_value'] : null; 

        if ($change_interval !== null) {
            $sql = "UPDATE control SET Cnumber = '$change_interval' WHERE Control = 'SendInterval'";
            mysqli_query($LinkId, $sql);
        }
        if ($change_channel !== null) {
            $sql = "UPDATE control SET Cnumber = '$change_channel' WHERE Control = 'SendRFChannel'";
            mysqli_query($LinkId, $sql);
            $new_sendcmd_enabled = 2;
        }
        if ($change_nomsg !== null) {
            $sql = "UPDATE control SET Cnumber = '$change_nomsg' WHERE Control = 'SendRFNomsg'";
            mysqli_query($LinkId, $sql);
            $new_sendcmd_enabled = 3;
        }
        // Update the control table
        $sql = "UPDATE control SET Cnumber = '$new_sendcmd_enabled' WHERE Control = 'SendCmdEnabled'";
        mysqli_query($LinkId, $sql);

        //header('Location: ' . "sensorlist.php");
        //exit();
    }else {
        // Update the control table
        $sql = "UPDATE control SET Cnumber = '$new_sendcmd_enabled' WHERE Control = 'SendCmdEnabled'";
        mysqli_query($LinkId, $sql);
    }
} 
$sql = "select * from control";
$control[] = array();
$result = mysqli_query($LinkId, $sql);
while ($row = mysqli_fetch_array($result)) {
    $control[$row["Control"]] = [$row["Cnumber"], $row["Ctext"]];
}
// Header Fields
$wlanip = $control['IP'][1];
$nodeid = $control['NodeId'];
$deviceid = "JRF" . $nodeid[1];
$timezone = $control['Timezone'][1];
$connect_status = false;
$rfversion = $control['RFVersion'][1];
$rfdevid = $control['RFDeviceId'][1];
$serverstatus = $control["ServerStatus"][0];
$mqttstatus = $control["MQTTStatus"][0];
$rfchannel = $control["RFChannel"][0];
$sendcmd_enabled = $control["SendCmdEnabled"][0];  
$default_channel = $control["SendRFChannel"][0];
$send_interval = $control["SendInterval"][0];
$SendRFNomsg = $control["SendRFNomsg"][0];
if ($send_interval == 0 ) $send_interval = 5; // Default send interval in minutes
if ($SendRFNomsg == 0 ) $SendRFNomsg = 1; // Default send msg in minutes
if ($default_channel == 0 ) $default_channel = $rfchannel; // Default channel if not set

// if New SSID Start WiFI if not IP
date_default_timezone_set($timezone);
$datetime = date('Y-m-d H:i:s', time());
$datetime2 = date('Y-m-d H:i:s', time());

include 'header.php'; ?>
<tr>
    <td columspan='3'>
        <table align='center' id="optionstable">
            <tr>
                <td colspan='3' style='text-align: center;'>
                    <h3>On Sensor Startup</h3>
                    <p>Send a Command to a sensor on sensor startup.</p>
                    <p>This is used to set sensors with
                        common configuration parameters automatically. Limitation of one Message Type at a time.</p>
                </td>
            </tr>
            <tr>
                <td> </td>
                <td> </td>
                <td> </td>
            </tr>
            <tr>
                <td colspan='3'>
                    <hr>
                </td>
            </tr>
            <form method='post' action='sendonstarted.php'>
                <tr>
                    <td colspan=2 style='text-align: right;'>Send Message on Startup Enabled : </td>
                    <td style='text-align: left' ;><Select name='sendcmd_enabled' onchange="flagchanged(name);">
                            <?php if ($sendcmd_enabled == 0) { ?>
                                <option value='0' Selected>Disabled</option>
                                <option value='1'>Enabled</option>
                            <?php } else { ?>
                                <option value='0'>Disabled</option>
                                <option value='1' Selected>Enabled</option>
                            <?php } ?>

                        </Select>
                    </td>
                </tr>
            <tr>
                <td colspan='3'>
                    <hr>
                </td>
            </tr>
                <tr><td colspan="3" style='text-align: center; font-weight:bold;'> Message Type </td></tr>
                <tr>
                    <td colspan=2 style='text-align: right;'>Change Send Interval : </td>
                    <td style='text-align: left;'>
                        <input type="checkbox" name="change_interval" value="1"
                            onchange="toggleExclusive('change_interval', ['change_channel', 'change_nomsg'])" <?php if ($sendcmd_enabled == 1) echo "checked = 'checked'";?> >
                        <input type="number" id="interval_value" name="interval_value" size="2"  
                            placeholder="Interval" min="1" max="9" value="<?php echo $send_interval; ?>"  onchange="flagchanged(name);"> Minutes
                    </td>
                </tr>
                <tr>
                    <td colspan=2 style='text-align: right;'> Change Channel : </td>
                    <td>
                        <input type="checkbox" name="change_channel" value="1"
                            onchange="toggleExclusive('change_channel', ['change_interval', 'change_nomsg'])" <?php if ($sendcmd_enabled == 2) echo "checked = 'checked'"; ?>>
                        <input type="number" id="channel_value" name="channel_value" size="2" 
                            placeholder="Channel" min="0" max="9" value="<?php echo $default_channel; ?>"  onchange="flagchanged(name);">
                    </td>
                </tr>
                <tr>
                    <td colspan=2 style='text-align: right;'> Change Number of Messages : </td>
                    <td>
                        <input type="checkbox" name="change_nomsg" value="1"
                            onchange="toggleExclusive('change_nomsg', ['change_interval', 'change_channel'])" <?php if ($sendcmd_enabled == 3) echo "checked = 'checked'"; ?>>
                        <input type="number" id="nomsg_value" name="nomsg_value" size="2" 
                            placeholder="Number of Messages" min="1" max="9" value="<?php echo $SendRFNomsg; ?>"  onchange="flagchanged(name);">
                    </td>
                </tr>
                <tr>
                    <td colspan="3" style="text-align: center;">
                        <input type='submit' name='submit' style='font-size:14px; border-radius:15px;-moz-border-radius:15px;-webkit-border-radius:15px; height:40px; width:90px; color: black; background-color:
                                    <?php if ($reset == 1) {
                                        echo "yellow";
                                    } else {
                                        echo "#C0C0C0";
                                    } ?>;' value='Save'>&nbsp;&nbsp;&nbsp;
                    </td>
                </tr>
            </form>
        </table>
    </td>
</tr>
<script>
    function toggleInput(inputId, isChecked) {
        const inputElement = document.getElementById(inputId);
        if (inputElement) {
            inputElement.style.display = isChecked ? 'inline' : 'none';
        }
    }

    function toggleExclusive(currentId, otherIds) {
        const currentCheckbox = document.getElementsByName(currentId)[0];
        if (currentCheckbox) {
            otherIds.forEach(otherId => {
                const otherCheckbox = document.getElementsByName(otherId)[0];
                if (otherCheckbox) {
                    otherCheckbox.checked = false;
                    toggleInput(`${otherId}_value`, false);
                }
            });
            toggleInput(`${currentId}_value`, currentCheckbox.checked);
        }
    }
</script>

<?php include 'footer.php'; ?>