<?php
// Get Header information
//
include 'dbconnect.php';
$sql = "select * from control";
$control[] = array();
$result = mysqli_query($LinkId, $sql);
while ($row = mysqli_fetch_array($result)) {
    $control[$row["Control"]] = [$row["Cnumber"] ,$row["Ctext"]];
}
// Header Fields
$wlanip = $control['IP'][1];
$nodeid = $control['NodeId'];
$deviceid = "JRF".$nodeid[1];
$timezone = $control['Timezone'][1];
$connect_status = false;
$rfversion = $control['RFVersion'][1];
$rfdevid = $control['RFDeviceId'][1];
$serverstatus = $control["ServerStatus"][0];
$mqttstatus = $control["MQTTStatus"][0];
$rfchannel = $control["RFChannel"][0];

if (isset($_GET["clearlist"])) {
   // echo "Clear List";
    $sql = "delete from sensorlist where id > 0";
    $result = mysqli_query($LinkId, $sql);
    header('Location: '."sensorlist.php");
    die();
}

// if New SSID Start WiFI if not IP
date_default_timezone_set($timezone);
$datetime = date('Y-m-d H:i:s', time());
$datetime2 = date('Y-m-d H:i:s', time());

include 'header.php'; ?>

<meta http-equiv="refresh" content="30">

<tr>
    <td align='center' style='color:black;'>List of Connected Devices</td>
</tr>
<tr>
    <td>
        <table align='center' style='width:550px;'>
            <tr style='color: #000088;' align='center'>
                <td width='20%'>Sensor</td>
                <td width='20%' align='left'>MQTT Key</td>
                <td width='10%'>Value</td>
                <td width='15%'>Count</td>
                <td width='35%'>Updated</td>
            </tr>
            <?php
            $totalcount = 0;
            $result = mysqli_query($LinkId,"SELECT * FROM sensorlist order by mqttkey") or die('Error');
            while($row = mysqli_fetch_array($result))
            {
                echo "<tr align='center' style='color: #000088;'>";
                echo "<td>".$row['deviceid']."</td>";
                echo "<td align='left'>".$row['mqttkey']."</td>";
                echo "<td>".$row['lvalue']."</td>";
                echo "<td>".$row['count']."</td>";
                $dateTime = new DateTime($row['RxTime'], new DateTimeZone('UTC'));
                $dateTime->setTimezone(new DateTimeZone($timezone));
                $rxtime = $dateTime->format('m-d-y / h:i:s a');
                echo "<td>".$rxtime."</td>";
                echo "</tr>";
                $totalcount = $totalcount + $row['count'];
            }
            ?>
            <tr align='center'>
                <td colspan='4' align='center'><br />----------------------------------------------------------------</td>
            </tr>
            <tr align='center'>
                <td><button onclick='ClearFunction()'>Clear List</button></td>
                <td colspan='2'>Total of Messages Processed</td>
                <td><?php echo $totalcount;?></td>
                <td><button onclick='SendCmdFunction()'>Send Command</button></td>
            </tr>
            <tr>
                <td></td>
                <td></td>
                <td></td>
                <td></td>
                <td></td>
            </tr>
        </table>
    </td>
<tr>
    <td colpan='2'><span style='color:#0033ff;'><span style='font-family:comic sans ms,cursive;'><span style='font-size:14px;'>
                    <p></p>
                </span></span></span></td>
</tr>
<tr>
    <td>
        <table>
            <tr>
                <form method='get' action='datadump.php'>
                    <td style='text-align: right;'><label for="datetime">Export Start Date :</label> </td>
                    <td><input type="date" id="datetime" name="datetime" value="<?php echo date('Y-m-d', time()); ?>" min="2023-06-07" /></td>
                    <td style='text-align: right;'>
                    <input type='submit' name='submit' style='font-size:14px; border-radius:15px;-moz-border-radius:15px;-webkit-border-radius:15px; height:40px; width:90px; color: black; background-color: #C0C0C0;' value='Show'>

                </form>
                <form method='get' action='sftpconf.php'>
            <td style='text-align: right;'>&nbsp;&nbsp;
                    <input type='submit' name='submit' style='font-size:14px; border-radius:15px;-moz-border-radius:15px;-webkit-border-radius:15px; height:40px; width:120px; color: black; background-color: #C0C0C0;' value='Export Settings'>
                </form>   </td>
            </tr>
        </table>
    </td>
</tr>


<?php include 'footer.php'; ?>