<?php
include 'dbconnect.php';
$reset = 0;
if (isset($_GET["clear"])) {
    //echo "reset";
    $sftp_enabled = 0;
    $sftp_host = "";
    $ftp_port = "22";
    $sftp_user = "";
    $sftp_password = "";
    $sftp_path ="";
    $sftp_send ="";
    $reset = 1;
    $tx_domain ="";
    $tx_method = "Linux";

    // write db updates
    //echo "Clear db";
    #updateControl();
} else {
    if ($_GET['submit'] == 'Save') {
        readControl();
        // test if new value
        $new_values = 0;
        if ($sftp_enabled != $_GET['sftp_enabled']) $new_values = 1;
        if ($sftp_host != $_GET['sftp_host']) $new_values = 1;
        if ($ftp_port != $_GET['ftp_port']) $new_values = 1;
        if ($sftp_user != $_GET['sftp_user']) $new_values = 1;
        if ($sftp_password != $_GET['sftp_password']) $new_values = 1;
        if ($sftp_path != $_GET['sftp_path']) $new_values = 1;
        if ($sftp_send != $_GET['sftp_send']) $new_values = 1;
        if ($tx_domain != $_GET['tx_domain']) $new_values = 1;
        if ($tx_method != $_GET['tx_method']) $new_values = 1;
    }
    if ($new_values == 1) {
        // Set static IP
        $sftp_enabled = htmlentities($_GET['sftp_enabled']);
        $sftp_host = htmlentities($_GET['sftp_host']);
        $ftp_port = htmlentities($_GET['ftp_port']);
        $sftp_user = htmlentities($_GET['sftp_user']);
        $sftp_password = htmlentities($_GET['sftp_password']);
        $sftp_path = htmlspecialchars($_GET['sftp_path']);
        $sftp_send = htmlentities($_GET['sftp_send']);
        $tx_domain = htmlentities($_GET['tx_domain']);
        $sftp_path = str_replace('\\','/',$sftp_path);
        $tx_method = htmlentities($_GET['tx_method']);
        updateControl();
    }
    readControl();
}

$refreshtime = 0;
if (isset($_GET["test"])) {

    $testdate = date("Y-m-d",time());
    $url = "http://localhost/dataexport.php?datetime=".$testdate."&submit=Export&delimiter=%2C";
    $response = file_get_contents($url);
    if ($response === FALSE) {
        // Handle error
        die( "Error occurred");
    }
    $file = fopen("sftp.txt", "w");
    fwrite($file,"#!/bin/bash");

    if ($tx_method == 'Windows'){

        $sftp_command = 'sudo mount -t cifs '.$sftp_path.' /var/www/html/remote -o user='.$sftp_user.',pass='.$sftp_password.',dom='.$tx_domain ;
        fwrite($file,"\n".$sftp_command);
        $sftp_command = 'sudo cp /var/www/html/temp.csv /var/www/html/remote/';
        fwrite($file,"\n".$sftp_command);
        $sftp_command = 'sudo umount remote';
        fwrite($file,"\n".$sftp_command);
    }else {
        $sftp_command = '/usr/bin/sshpass -p "'.$sftp_password.'" /usr/bin/scp -o StrictHostKeyChecking=no  /var/www/html/temp.csv '.$sftp_user.'@'.$sftp_host.':'.$sftp_path ;
        fwrite($file,"\n".$sftp_command);
    }
    fclose($file);
    unlink("sftp_OK");
    unlink("sftp_Failed");
    $refreshtime = getrefreshtime() + 10;
    echo "File is Queued to send, please wait ",$refreshtime , " seconds to complete.";
}

$sftp_status ="White";
$sftp_sent = "";
date_default_timezone_set($timezone);
if (file_exists("sftp_OK") == 1){
    $sftp_status = "LightGreen";
    $sftp_sent = date ("m d Y h:i A", filemtime("sftp_OK"));
}
if (file_exists("sftp_Failed") == 1){
    $sftp_status = "LightPink";
    $sftp_sent = date ("m d Y h:i A", filemtime("sftp_Failed"));
}

function getrefreshtime(){
    $secondsafter = date("s", time());
    while ( $secondsafter > 10 ){
        $secondsafter = $secondsafter - 10;
    }
    $refreshtime = (10 - $secondsafter);
    return $refreshtime;
}

// Get list of available SSIDs
function readControl()
{
    global $LinkId, $wlanip, $deviceid, $serverstatus, $mqttstatus, $sftp_enabled,$sftp_host,$ftp_port, $sftp_user,
    $sftp_password,$sftp_path,$sftp_send,$timezone,$rfversion,$tx_domain,$tx_method,$rfchannel, $rfdevid;

    $sql = "select * from control";
    $control[] = array();
    $result = mysqli_query($LinkId, $sql);
    while ($row = mysqli_fetch_array($result)) {
        $control[$row["Control"]] = [$row["Cnumber"], $row["Ctext"]];
    }
    // Header Fields
    $wlanip = $control['IP'][1];
    $nodeid = $control['NodeId'];
    $deviceid = "JRF" . $nodeid[1];
    $timezone = $control['Timezone'][1];
    $rfversion = $control['RFVersion'][1];
    $rfdevid = $control['RFDeviceId'][1];
    $rfchannel = $control["RFChannel"][0];
    $serverstatus = $control["ServerStatus"][0];
    $mqttstatus = $control["MQTTStatus"][0];

    $sftp_enabled = $control['SFTP_Enabled'][0];
    $sftp_host = $control['SFTP_Host'][1];
    $ftp_port = $control['SFTP_Port'][1];
    $sftp_user = $control['SFTP_User'][1];
    $sftp_password = $control['SFTP_Password'][1];
    $sftp_path = $control['SFTP_Path'][1];
    $sftp_send = $control['SFTP_Send'][1];
    $tx_domain = $control['TX_Domain'][1];
    $tx_method = $control['TX_Method'][1];
}

function updateControl()
{
    global $LinkId, $sftp_enabled,$sftp_host,$ftp_port, $sftp_user,$sftp_password,$sftp_path,$sftp_send,$tx_domain,$tx_method;

    $sql = "update control set Cnumber = '$sftp_enabled' where Control ='SFTP_Enabled'";
    $result = mysqli_query($LinkId, $sql);
    $sql = "update control set Ctext = '$sftp_host' where Control ='SFTP_Host'";
    $result = mysqli_query($LinkId, $sql);
    $sql = "update control set Ctext = '$ftp_port' where Control = 'SFTP_Port'";
    $result = mysqli_query($LinkId, $sql);
    $sql = "update control set Ctext = '$sftp_user' where Control = 'SFTP_User'";
    $result = mysqli_query($LinkId, $sql);
    $sql = "update control set Ctext = '$sftp_password' where Control = 'SFTP_Password'";
    $result = mysqli_query($LinkId, $sql);
    $sftp_path = str_replace("\\", "\\\\", $sftp_path);
    $sql = "update control set Ctext = '$sftp_path' where Control = 'SFTP_Path'";
    $result = mysqli_query($LinkId, $sql);
    $sql = "update control set Ctext = '$sftp_send' where Control = 'SFTP_Send'";
    $result = mysqli_query($LinkId, $sql);
    $sql = "update control set Ctext = '$tx_domain' where Control = 'TX_Domain'";
    $result = mysqli_query($LinkId, $sql);
    $sql = "update control set Ctext = '$tx_method' where Control = 'TX_Method'";
    $result = mysqli_query($LinkId, $sql);
    if (!$result) {
        echo "Error: " . $sql . "<br>" . mysqli_error($LinkId);
    }
}

$host_color  = "White";
$port_color  = "White";
if (strlen($sftp_host) > 0 and $sftp_enabled == 1 and $tx_method == 'Linux') {
    if (strpos(shell_exec("ping -c 1 $sftp_host"), "1 received") == true) {
        $host_color = "LightGreen";
    } else {
        $host_color = "LightPink";
    }
    $server ="nc -w1"." ". $sftp_host." ".$ftp_port ;
    if (strlen(shell_exec($server)) > 1) {
        $port_color = "LightGreen";
        $host_color = "LightGreen";     # Host may have ping blocked, if port works server good
    } else {
        $port_color = "LightPink";
    }
}

// if New SSID Start WiFI if not IP
date_default_timezone_set($timezone);
$datetime = date('Y-m-d H:i:s', time());

include 'header.php';
if ($refreshtime > 0)  echo '<meta http-equiv="refresh" content="',$refreshtime,';URL=sftpconf.php">';
?>
<script>
    function showUpdate() {
        alert('If you want the Gateway to use DHCP, leave the first four fields marked with a "*", blank.');
    }
function showmethod(name) {
    flagchanged(name);
    setmethod(name);
}

</script>
<tr>
    <td columspan='2'>
        <table align='center' id = "optionstable">
            <tr>
                <td colspan='3' style='text-align: center;'><h3>Export Prior Daily Report</h3></td>
            </tr>
            <form method='get' action='sftpconf.php' >
                <tr>
                    <td  colspan=2 style='text-align: right;'>Transfer enabled : </td>
                    <td style='text-align: left' ;><Select name='sftp_enabled' onchange="flagchanged(name);">
                        <?php if($sftp_enabled == 0){?>
                            <option value='0' Selected>Disabled</option>
                            <option value='1'>Enabled</option>
                            <?php }else{?>
                            <option value='0' >Disabled</option>
                            <option value='1' Selected>Enabled</option>
                            <?php }?>

                        </Select>
                    </td>
                    <td></td>
                </tr>
                <tr>
                    <td colspan=2  style='text-align: right;'><label for="sftp_send">Send to Server at :</label> </td>
                    <td><input type="time" name="sftp_send" value="<?php echo $sftp_send; ?>" min="2023-06-07 00:00:00"  onchange="flagchanged(name);"> (for Previous day)</td>
                </tr>
                <tr>
                    <td colspan=2  style='text-align: right;'>Last Send was : </td>
                    <td style='text-align: left' ;><input type='text' name='sftp_sent' disabled style="background-color:<?php echo $sftp_status; ?>;" maxlength='45' size='15' value='<?php echo $sftp_sent; ?>'></td>
                    <td></td>
                </tr>
                <tr><td colspan=3><hr></td></tr>
                <tr>
                    <td colspan=2  style='text-align: right;'>User : </td>
                    <td style='text-align: left' ;><input type='text' name='sftp_user' maxlength='45' size='15' value='<?php echo $sftp_user; ?>' onchange="flagchanged(name);"></td>
                    <td></td>
                </tr>
                <tr>
                    <td colspan=2 style='text-align: right;'> Password : </td>
                    <td style='text-align: left' ;><input type='password' name='sftp_password' id='sftp_password' maxlength='45' size='15' value='<?php echo $sftp_password; ?>' onchange="flagchanged(name);">
                    &nbsp;&nbsp;&nbsp;
    <button type="button" id="toggleButton">Show Password</button></td><td></td>
                </tr>
                <tr>
                    <td colspan=2  style='text-align: right;'> Path : </td>
                    <td colspan=2 style='text-align: left' ;><input type='text' name='sftp_path' maxlength='55' size='30' value='<?php echo $sftp_path; ?>' onchange="flagchanged(name);"></td>

                </tr><tr><td colspan=3><hr></td></tr>

                <tr>
                    <td  colspan=2 style='text-align: right;'>Transfer Method: </td>
                    <td style='text-align: left' ;><Select name='tx_method' id ='tx_method'  onchange="showmethod(name);">
                        <?php if($tx_method == "Windows"){?>
                            <option value='Windows' Selected>Windows</option>
                            <option value='Linux'>Linux</option>
                            <?php }else{?>
                            <option value='Windows' >Windows</option>
                            <option value='Linux' Selected>Linux</option>
                            <?php }?>

                        </Select>
                    </td>
                    <td></td>
                </tr>
                <tr><td colspan=3>
                    <div id ="Linux">
                        <table>
                            <tr ><td colspan=3 style='text-align: center;'>Linux SFTP Transfer Selected, Enter</td>
                                </tr>
                            <tr>
                                <td colspan=2 style='text-align: right;'>SFTP Server : </td>
                                <td style='text-align: left' ;><input style="background-color:<?php echo $host_color;?>;" type='text' name='sftp_host' maxlength='45' size='15' value='<?php echo $sftp_host; ?>' onchange="flagchanged(name);"></td>
                                <td></td>
                            </tr>
                            <tr>
                            <td colspan=2 style='text-align: right;'>SFTP Port : </td>
                                <td style='text-align: left' ;><input style="background-color:<?php echo $port_color;?>;" type='text' name='ftp_port' maxlength='15' size='15' value='<?php echo $ftp_port; ?>' onchange="flagchanged(name);"></td>
                                <td></td>
                            </tr>
                        </table>
                    </div>

                    <div id = "Windows">
                        <table>
                            <tr>
                            <td colspan=3 style='text-align: center;'>Windows File Share Transfer Selected, Enter
                            </td>
                        </tr>
                        <tr>
                            <td colspan=2 style='text-align: right;'>Domain : </td>
                            <td style='text-align: left' ;><input  type='text' name='tx_domain' maxlength='15' size='15' value='<?php echo $tx_domain; ?>' onchange="flagchanged(name);"></td>
                            <td></td>
                        </tr>
                                </table>
                    </div>
                    </td>
                </tr>
                <tr>
                <td xolspan=3>&nbsp;&nbsp;&nbsp; </td>
                </tr>
                <tr>
                    <td colspan="3" style="text-align: center;">
                        <input type='submit' name='submit' style='font-size:14px; border-radius:15px;-moz-border-radius:15px;-webkit-border-radius:15px; height:40px; width:90px; color: black; background-color:
                                    <?php if ($reset == 1){ echo "yellow"; }else {echo "#C0C0C0";} ?>;' value='Save'>&nbsp;&nbsp;&nbsp;
                        <button style='text-align: center;font-size:14px; border-radius:15px;-moz-border-radius:15px;-webkit-border-radius:15px; height:40px; width:90px; color: black; background-color: #C0C0C0;'>
                            <a href='sftpconf.php?test'>Test Send</a></button>
                            &nbsp;&nbsp;&nbsp;
                        <button style='text-align: center;font-size:14px; border-radius:15px;-moz-border-radius:15px;-webkit-border-radius:15px; height:40px; width:90px; color: black; background-color: #C0C0C0;'>
                            <a href='sftpconf.php?clear'>Reset Form</a></button>

                    </td>

                </tr>
            </form>
        </table>
    </td>
</tr>
<?php include 'footer.php';?>