<?php
// This task runs every minute to check Sftp Send Report time
//

include 'dbconnect.php';

$sql = "select * from control";
$control[] = array();
$result = mysqli_query($LinkId, $sql);
while ($row = mysqli_fetch_array($result)) {
    $control[$row["Control"]] = [$row["Cnumber"], $row["Ctext"]];
}
// Header Fields
$wlanip = $control['IP'][1];
$nodeid = $control['NodeId'];
$deviceid = "JRF" . $nodeid[1];
$connect_status = false;
$timezone = $control['Timezone'][1];
$ip = $control["IP"][1];

$sftp_enabled = $control['SFTP_Enabled'][0];
$sftp_host = $control['SFTP_Host'][1];
$ftp_port = $control['SFTP_Port'][1];
$sftp_user = $control['SFTP_User'][1];
$sftp_password = $control['SFTP_Password'][1];
$sftp_path = $control['SFTP_Path'][1];
$sftp_send = $control['SFTP_Send'][1];
$sftp_delimiter = $control['SFTP_Delimiter'][1];
$tx_domain = $control['TX_Domain'][1];
$tx_method = $control['TX_Method'][1];

if ($sftp_enabled == 0) die("SFTP Not Enabled");

date_default_timezone_set($timezone);
$nowtime = date('H:i',time());
//$ftp_send = $nowtime;
if ($nowtime != $sftp_send){
    Die( "Send time is $sftp_send and now it is $nowtime so I quite");
}
// Generate prior day date for report
$datetime = date('Y-m-d', strtotime($sftp_send.' -1 day'));


echo 'Sent at:', $datetime;

$baseurl = "http://".$ip;
$URL = $baseurl."/dataexport.php?datetime=".$datetime."&delimiter=".$sftp_delimiter."&sftp";
$req = file_get_contents($URL);
echo $URL;

$EndTime = time();
$Ended = date("Y-m-d H:i:s",time());
echo 'Completed: '.$Ended;
echo ' Run Time was: ',$EndTime - $StartTime ;
if($req == FALSE) {
    echo 'SMS Url failed: '.$URL.'<br />';
}
echo '<br />';
// clear prior status
unlink("sftp_OK");
unlink("sftp_Failed");
//
echo "Sending to remote host";
$filename = $datetime.".csv";
$file = fopen("sftp.txt", "w");

fwrite($file,"#!/bin/bash");

if ($tx_method == 'Windows'){
    $sftp_command = 'sudo mount -t cifs '.$sftp_path.' /var/www/html/remote -o user='.$sftp_user.',pass='.$sftp_password.',dom='.$tx_domain ;
    fwrite($file,"\n".$sftp_command);
    $sftp_command = 'sudo cp /var/www/html/temp.csv /var/www/html/remote/'.$filename;
    fwrite($file,"\n".$sftp_command);
    $sftp_command = 'sudo umount remote';
    fwrite($file,"\n".$sftp_command);
}else {
    $sftp_command = '/usr/bin/sshpass -p "'.$sftp_password.'" /usr/bin/scp -o StrictHostKeyChecking=no  /var/www/html/temp.csv '.$sftp_user.'@'.$sftp_host.':'.$sftp_path.$filename ;
    fwrite($file,"\n".$sftp_command);
}
fclose($file);
