<?php
// Get Header information
//
include 'dbconnect.php';
if (isset($_GET["StatusInterval"])){
    // update interval
    $StatusInterval = filter_var($_GET["StatusInterval"], FILTER_VALIDATE_INT );
    $sql = "update control set CNumber = '$StatusInterval' where Control ='StatusInterval'";
    $result = mysqli_query($LinkId, $sql);
}
if (isset($_GET["Clear"])){
    $sql = "truncate table Sensorerrors;";
    $result = mysqli_query($LinkId, $sql);
}
$sql = "select * from control";
$control[] = array();
$result = mysqli_query($LinkId, $sql);
while ($row = mysqli_fetch_array($result)) {
    $control[$row["Control"]] = [$row["Cnumber"] ,$row["Ctext"]];
}
// Header Fields
$wlanip = $control['IP'][1];
$nodeid = $control['NodeId'];
$deviceid = "JRF".$nodeid[1];
$timezone = $control['Timezone'][1];
$connect_status = false;
$rfversion = $control['RFVersion'][1];
$rfchannel = $control["RFChannel"][0];
$rfdevid = $control['RFDeviceId'][1];
$serverstatus = $control["ServerStatus"][0];
$mqttstatus = $control["MQTTStatus"][0];
//
$sendstart = $control["SendStart"][1];
$sendversion = $control["SendVersion"][1];
$wirelessstart = $control["WTStart"][1];
$wirelessversion = $control["WTVersion"][1];
$LEDVersion = $control["LEDVersion"][1];
$LEDStart = $control["LEDStart"][1];
$cmdstart = $control["CmdStart"][1];
$cmdversion = $control["CmdVersion"][1];
$hcversion = $control["HCVersion"][1];
$hcstart = $control['HCPID'][1];
$cputemp = $control["CPUTemp"][1];
$gputemp = $control["GPUTemp"][1];
//$rfrcount = $control["FIFOCount"][0];
$rfcount = $control["RFCount"][0];
$StatusInterval = $control["StatusInterval"][0];

$sql = "select sum(count) as rxcount from sensorlist;";
$result = mysqli_query($LinkId, $sql);
$row = mysqli_fetch_row($result);
$rfrcount = $row[0];
if (empty($row[0])) $rfrcount = 0;   // test for no rx counts

$rfrutc = $control["RFResetCount"][1];
//
// Format the timestamp in the target timezone
$rfrutcd = new DateTime($rfrutc, new DateTimeZone('UTC'));
$rfrutcd->setTimezone(new DateTimeZone($timezone));
$rfrtime = $rfrutcd->format('Y-m-d H:i:s');

// if New SSID Start WiFI if not IP
date_default_timezone_set($timezone);
$datetime = date('Y-m-d H:i:s', time());

$systemstatus = shell_exec("ps -aef |grep gw2");

if (strpos($systemstatus,'gw2led.py') > 1){
    $gw2led = "#09de42";
} else {
    $gw2led = "#f54049";
}
if (strpos($systemstatus,'gw2cmd.py') > 1){
    $gw2cmd = "#09de42";
} else {
    $gw2cmd = "#f54049";
}
if (strpos($systemstatus,'gw2wireless.py') > 1){
    $gw2wireless = "#09de42";
} else {
    $gw2wireless = "#f54049";
}
if (strpos($systemstatus,'gw2send.py') > 1){
    $gw2send = "#09de42";
} else {
    $gw2send = "#f54049";
}
if (strpos($systemstatus,'gw2healthcheck.py') > 1){
    $gw2healthcheck = "#09de42";
} else {
    $gw2healthcheck = "#f54049";
}
$cputempcolor = "#09de42";          //Green
if ($cputemp > 160 or $gputemp > 160){
    $cputempcolor = "#ebe534";     // Yellow
}
if ($cputemp >= 170 or $gputemp > 170){
    $cputempcolor = "#f54049";      //Red
}
$rfrtempcolor = "#09de42";

if ($rfrcount == $rfcount) {                // No change in rx data, test how long
    $sql = "select * from fifo order by idfifo desc limit 1";
    $lastrx[] = array();
    $result = mysqli_query($LinkId, $sql);
    $lastrx = mysqli_fetch_array($result);

    $targetTime = new DateTime($lastrx["CTime"]);
    // Get the current time
    $currentTime = new DateTime();

    // Calculate the time difference in seconds
    $interval = $currentTime->diff($targetTime);
    $timeDifferenceInSeconds = ($interval->days * 24 * 60 * 60) + ($interval->h * 60 * 60) + ($interval->i * 60) + $interval->s;

    // Check if the time difference is greater than 30 minutes (1800 seconds)
    $timeinterval = 60 * 2000;  // 20 minutes
    if ($timeDifferenceInSeconds > $timeinterval) $rfrtempcolor = "#ffd633";      //Orange

}

include 'header.php'; ?>

<meta http-equiv="refresh" content="60">

<tr>
    <td align='center' style='color:black;'>Gateway System Health</td>
</tr>
<tr>
    <td>
        <table align='center' style='width:500px;'>
            <tr style='color: #000088;' align='center'>
                <td></td>
                <td width='50%' style="text-align:center;"> &nbsp;&nbsp;Application</td>
                <td style="text-align:left;">Version</td>
                <td width = '20%' style="text-align:left;">Started</td>
            </tr>
            <tr>
                <td></td>
                <td style="text-align:right;">HTTP Server Connector&nbsp;&nbsp;</td>
                <td colspan="2" style="text-align:center;background-color:<?php echo $gw2cmd;?>;"><?php echo 'Ver ', $cmdversion,' - ',$cmdstart;?></td>
            </tr>
            <tr>
                <td></td>
                <td style="text-align:right;">Sensor Receiver&nbsp;&nbsp;</td>
                <td colspan="2" style="text-align:center;background-color:<?php echo $gw2wireless;?>;"><?php echo 'Ver ', $wirelessversion,' - ',$wirelessstart;?></td>

            </tr>
            <tr>
                <td></td>
                <td style="text-align:right;">HTTP/MQTT Sender&nbsp;&nbsp;</td>
                <td colspan="2"  style="text-align:center;background-color:<?php echo $gw2send;?>;"><?php echo 'Ver ', $sendversion,' - ',$sendstart;?></td>

            </tr>
            <tr>
                <td></td>
                <td style="text-align:right;">Health Check&nbsp;&nbsp;</td>
                <td colspan="2" style="text-align:center;background-color:<?php echo $gw2healthcheck;?>;"><?php echo 'Ver ', $hcversion,' - ',$hcstart;?></td>

            </tr>
            <tr>
                <td></td>
                <td style="text-align:right;">Status Light&nbsp;&nbsp;</td>
                <td colspan="2" style="text-align:center;background-color:<?php echo $gw2led;?>;"><?php echo 'Ver ', $LEDVersion,' - ',$LEDStart;?></td>

            </tr>
            <tr><td colspan="4"><hr></td></tr>
            <?php
                $sql = 'select * from Sensorerrors';
                $result = mysqli_query($LinkId, $sql);
                $firstrow = 0;
                while ($row = mysqli_fetch_array($result)) {
                    if ($firstrow == 0){
                        echo '<tr><td colspan="4" style="text-align: center;">Sensors Having Problems</td></tr>';
                        $firstrow = 1;
                    }
                    echo '<tr><td colspan="2"  style="text-align:right;">',$row["RxTime"],' - Sensor </td><td colspan="2"  style="text-align:left;">' ,$row["deviceid"]," - ",$row["issue"],"</td></tr>";
                }
                if ($firstrow == 0){
                      echo '<tr><td colspan="4" style="text-align: center;">Sensor Status Good</td></tr>';
                }else{
                    ?>
                    <tr><td colspan="4"> &nbsp;</td></tr>
                    <tr>
                    <td colspan="2" style="text-align: right;">Reset Sensor Error List</td>
                    <td colspan="2" align="center">
                        <button style='text-align: center;font-size:14px; border-radius:15px;-moz-border-radius:15px;-webkit-border-radius:15px; height:30px; width:100px; color: black; background-color:  #C0C0C0;'>
                                    <a href='systemhealth.php?Clear'>Reset List</a></button>
                    </td></tr>
                <?php
                }

            ?>
            <tr><td colspan="4"></td></tr>
            <tr><td colspan="4"><hr></td></tr>
            <tr>
                <td></td>
                <td style="text-align:right;">Process Temp&nbsp;&nbsp;</td>
                <td colspan="2" style="text-align:center;background-color:<?php echo $cputempcolor;?>;"><?php echo 'CPU ', $cputemp, '&nbsp;&nbsp; GPU ', $gputemp;?></td>

            </tr>
            <tr>
                <td></td>
                <td style="text-align:right;">RF Receiver Status&nbsp;&nbsp;</td>
                <td colspan="2" style="text-align:center;font-size:13px;background-color:<?php echo $rfrtempcolor;?>;"><?php echo 'Rx ', $rfrcount, '&nbsp;-&nbsp;', $rfrtime;?></td>

            </tr>
            <tr><td colspan="4"><hr></td></tr>
            <tr>
                <td colspan=2 style="text-align:right;">Send MQTT Status Every &nbsp;&nbsp;</td>
                <form method='get' action="systemhealth.php">
                <td style="text-align:center;">
                <input type='number' name='StatusInterval' size ='4'  min="1" max="66" value='<?php echo $StatusInterval ?>' onchange="flagchanged(name);"></td><td>
                <input type="submit" name="submit" value="Minutes" />
                </form></td>
                </td>
            </tr>
            <tr><td colspan="4"><hr></td></tr>
            <tr>
                <td></td>
                <td><button style='text-align: center;font-size:14px; border-radius:15px;-moz-border-radius:15px;-webkit-border-radius:15px; height:30px; width:120px; color: black; background-color:  #C0C0C0;'>
                                    <a href='sendlogs.php'>Download_Logs</a></button></td>
            <td colpan='2'><button style='text-align: center;font-size:14px; border-radius:15px;-moz-border-radius:15px;-webkit-border-radius:15px; height:30px; width:110px; color: black; background-color:  #C0C0C0;'>
                                    <a href='systemhealth.php'>Refresh</a></button></span></td>
            </tr>
            <tr>
                <td></td>
            </tr>

        </table>
    </td>
<tr>
</tr>

<?php include 'footer.php'; ?>